﻿using Syncfusion.Windows.Controls.Cells;
using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;

namespace DataContextDemo
{
    class SearchBehaviour : Behavior<Window>
    {
        GridDataControl SyncGrid;
        Button Button;
        TextBox SearchText;
        static int colIndex = 0, rowIndex = 0, index;
        protected override void OnAttached()
        {
            var window = this.AssociatedObject;
            this.SyncGrid = window.FindName("SyncGrid") as GridDataControl;
            this.Button = window.FindName("serachbutton") as Button;
            this.SearchText = window.FindName("searchTextBox") as TextBox;
            Button.Click += Button_Click;
        }

        void Button_Click(object sender, RoutedEventArgs e)
        {
            colIndex = this.SyncGrid.Model.CurrencyManager.CurrentCell.ColumnIndex;
            rowIndex = this.SyncGrid.Model.CurrencyManager.CurrentCell.RowIndex;
            if (this.SyncGrid.Model.View.GroupDescriptions.Count > 0)
            {
                index = this.SyncGrid.Model.CurrencyManager.CurrentCell.RowIndex;
                FindGroup(index);
            }
            FindNextCell();
        }
        private void FindGroup(int index)
        {
            var group = this.SyncGrid.Model.View.TopLevelGroup.DisplayElements[index - 1];
            if (group != null && this.SyncGrid.Model.View.TopLevelGroup.DisplayElements[index] != null)
            {
                if (this.SyncGrid.Model.View.TopLevelGroup.DisplayElements[index] is RecordEntry)
                {
                    var recordIndex = this.SyncGrid.Model.ResolveIndexToRecordPosition(index);
                    rowIndex = this.SyncGrid.Model.ResolvePositionToIndex(recordIndex);
                }
                else
                {
                    index++;
                    FindGroup(index);
                }
            }
            else
                rowIndex = 0;
        }

        public void FindNextCell()
        {
            string searchText = SearchText.Text;
            var count = this.SyncGrid.Model.View.GroupDescriptions.Count > 0
                            ? this.SyncGrid.Model.View.TopLevelGroup.DisplayElements.Count
                            : this.SyncGrid.Model.View.Records.Count;
            bool isTextHighlight = false;
            rowIndex = this.SyncGrid.Model.ResolveIndexToRecordPosition(rowIndex);
            for (int row = rowIndex + 1; row <= count; row++)
            {
                object record = null;
                if (this.SyncGrid.Model.View.GroupDescriptions.Count > 0)
                {
                    if (!(this.SyncGrid.Model.View.TopLevelGroup.DisplayElements[row] is RecordEntry))
                        continue;
                    var recordIndex = this.SyncGrid.Model.ResolveIndexToRecordPosition(row);
                    if (recordIndex == this.SyncGrid.Model.View.Records.Count)
                    {
                        record = this.SyncGrid.Model.View.Records.GetItemAt(0);
                        row = 0;
                    }
                    else
                        record = this.SyncGrid.Model.View.Records.GetItemAt(recordIndex);
                }
                else
                {
                    if (row == this.SyncGrid.Model.RowCount)
                    {
                        record = (this.SyncGrid.Model.View.Records[0] as RecordEntry).Data;
                        row = 0;
                    }
                    else
                        record = (this.SyncGrid.Model.View.Records[row] as RecordEntry).Data;
                }

                for (int col = this.SyncGrid.Model.ResolveVisibleColumnIndexToPosition(colIndex); col < this.SyncGrid.Model.ColumnCount - this.SyncGrid.Model.View.GroupDescriptions.Count; col++)
                {
                    string value;
                    if (record == null)
                        return;
                    value =
                        this.SyncGrid.Model.View.GetPropertyAccessProvider()
                                .GetValue(record, this.SyncGrid.VisibleColumns[col].MappingName)
                                .ToString();
                    if (value.ToLower().Contains(searchText.ToLower()))
                    {
                        isTextHighlight = true;
                        var scrollColIndex = this.SyncGrid.Model.ResolveVisibleColumnIndexToPosition(col);
                        var gridRowIndex = row;
                        //Move the Selection to next item which is searched.
                        int rowindex = this.SyncGrid.Model.ResolvePositionToIndex(gridRowIndex - this.SyncGrid.Model.View.GroupDescriptions.Count);

                        this.SyncGrid.Model.CurrencyManager.CurrentCell.MoveTo(new RowColumnIndex(rowindex, scrollColIndex));
                        //scroll the view the next item which is searched.
                        this.SyncGrid.Model.Grid.ScrollInView(new RowColumnIndex(rowindex, scrollColIndex));
                        return;
                    }
                }
                colIndex = this.SyncGrid.Model.View.GroupDescriptions.Count;
                if (row == count - 1 && !isTextHighlight)
                {
                    MessageBox.Show("Entered text not present in the grid");
                    return;
                }
            }
            rowIndex = 0;
            FindNextCell();
        }
    }
}
